Loading...
Searching...
No Matches
Sip_from

## Data Structures

struct | sip_addr_s
| Structure for From and To headers. More...

## Macros

#define | sip_from(sip)
| Access a SIP From header structure sip_from_t from sip_t.
#define | SIP_FROM_INIT()
| Initializer for structure sip_from_t.
#define | SIPTAG_FROM(x)
| Tag list item for pointer to a From header structure sip_from_t.
#define | SIPTAG_FROM_REF(x)
| Tag list item for reference to a From header pointer.
#define | SIPTAG_FROM_STR(s)
| Tag list item for string with From header value.
#define | SIPTAG_FROM_STR_REF(x)
| Tag list item for reference to a From header string.

## Typedefs

typedef struct sip_addr_s | sip_from_t
| @

## Functions

issize_t | sip_from_d (su_home_t *, msg_header_t *, char *s, isize_t slen)
| Parse a SIP From header.
issize_t | sip_from_e (char b[], isize_t bsiz, msg_header_t const *h, int flags)
| Print a SIP From header.
sip_from_t * | sip_from_init (sip_from_t x[1])
| Initialize a structure sip_from_t.
int | sip_is_from (sip_header_t const *header)
| Test if header object is instance of sip_from_t.
sip_from_t * | sip_from_dup (su_home_t *home, sip_from_t const *hdr))
| Duplicate a list of From header header structures sip_from_t.
sip_from_t * | sip_from_copy (su_home_t *home, sip_from_t const *hdr))
| Copy a list of From header header structures sip_from_t.
sip_from_t * | sip_from_make (su_home_t *home, char const *s))
| Make a From header structure sip_from_t.
sip_from_t * | sip_from_format (su_home_t *home, char const *fmt,...)))
| Make a From header from formatting result.
sip_from_t * | sip_from_create (su_home_t *home, url_string_t const *s)
| Create a From header object with URL.
int | sip_from_add_param (su_home_t *home, sip_from_t *from, char const *param)
| Add a parameter to an sip_from_t object.
int | sip_from_tag (su_home_t *home, sip_from_t *from, char const *tag)
| Add a tag to a From header.

## Variables

msg_hclass_t | sip_from_class []
| Header class for From header.
tag_typedef_t | siptag_from
| Tag for From header object.
tag_typedef_t | siptag_from_str
| Tag for string with From header value.

## Detailed Description

## Macro Definition Documentation

## SIP_FROM_INIT

#define SIP_FROM_INIT | ( |  | ) |

Initializer for structure sip_from_t.

A static sip_from_t structure for From header must be initialized with the SIP_FROM_INIT() macro. For instance,

sip_from_t sip_from = SIP_FROM_INIT;
SIP_FROM_INIT
#define SIP_FROM_INIT()
Initializer for structure sip_from_t.
Definition sip_protos.h:1814
sip_from_t
struct sip_addr_s sip_from_t
@
Definition sip.h:160
sip_from
#define sip_from(sip)
Access a SIP From header structure sip_from_t from sip_t.
Definition sip_protos.h:1797

## SIPTAG_FROM

#define SIPTAG_FROM | ( |  | x | ) |

Tag list item for pointer to a From header structure sip_from_t.

The SIPTAG_FROM() macro is used to include a tag item with a pointer to a sip_from_t structure in a tag list.

Parameters

  x | pointer to a sip_from_t structure, or NULL.

The corresponding tag taking reference parameter is SIPTAG_FROM_REF().

## SIPTAG_FROM_STR

#define SIPTAG_FROM_STR | ( |  | s | ) |

Tag list item for string with From header value.

The SIPTAG_FROM_STR() macro is used to include a tag item with a string containing value of a sip_from_t header in a tag list.

Parameters

  s | pointer to a string containing From header value, or NULL.

The string in SIPTAG_FROM_STR() can be converted to a sip_from_t header structure by giving the string s has second argument to function sip_from_make().

The corresponding tag taking reference parameter is SIPTAG_FROM_STR_REF().

## Typedef Documentation

## sip_from_t

typedef struct sip_addr_s sip_from_t

@

The From header indicates the initiator of the request. It is defined in RFC 3261 as follows:

From = ( "From" / "f" ) HCOLON from-spec
from-spec = ( name-addr / addr-spec )
*( SEMI from-param )
from-param = tag-param / generic-param
tag-param = "tag" EQUAL token

The parsed From header is stored in sip_from_t structure.

The structure sip_from_t contains representation of From header.

The sip_from_t is defined as follows:

typedef struct sip_addr_s {
sip_common_t a_common[1]; // Common fragment info
sip_error_t *a_next; // Link to next
char const *a_display; // Display name
url_t a_url[1]; // URL
msg_param_t const *a_params; // List of from-param
char const *a_comment; // Comment
char const *a_tag; // Tag parameter
} sip_from_t;
sip_error_t
msg_error_t sip_error_t
@
Definition sip.h:134
sip_common_t
msg_common_t sip_common_t
Common part of all the header structures.
Definition sip.h:121
sip_addr_s
Structure for From and To headers.
Definition sip.h:382
sip_addr_s::a_params
msg_param_t const * a_params
Parameter table.
Definition sip.h:387
sip_addr_s::a_url
url_t a_url[1]
URL.
Definition sip.h:386
sip_addr_s::a_common
sip_common_t a_common[1]
Common fragment info.
Definition sip.h:383
sip_addr_s::a_comment
char const * a_comment
Comment.
Definition sip.h:388
sip_addr_s::a_display
char const * a_display
Display name.
Definition sip.h:385
sip_addr_s::a_tag
char const * a_tag
Tag parameter.
Definition sip.h:390
url_t

## Function Documentation

## sip_from_add_param()

int sip_from_add_param | ( | su_home_t * | home,
|  | sip_from_t * | from,
|  | char const * | param )

Add a parameter to an sip_from_t object.

Parameters

  home | memory home
  from | a pointer to sip_from_t object
  param | parameter string

Return values

  0 | when successful
  -1 | upon an error

Deprecated
  Use msg_header_replace_param() directly.

## sip_from_copy()

sip_from_t * sip_from_copy | ( | su_home_t * | home,
|  | sip_from_t const * | hdr )

inline

Copy a list of From header header structures sip_from_t.

The function sip_from_copy() copies a header structure hdr. If the header structure hdr contains a reference (`hdr->h_next`) to a list of headers, all the headers in that list are copied, too. The function uses given memory home to allocate all the memory areas used to copy the list of header structure hdr.

Parameters

  home | memory home used to allocate new structure
  hdr | pointer to the header structure to be copied

When copying, only the header structure and parameter lists attached to it are duplicated. The new header structure retains all the references to the strings within the old hdr header, including the encoding of the old header, if present.

Example
  from = sip_from_copy(home, sip->sip_from);
  sip_from_copy
  sip_from_t * sip_from_copy(su_home_t *home, sip_from_t const *hdr))
  Copy a list of From header header structures sip_from_t.
  Definition sip_protos.h:1944

Returns
  A pointer to newly copied header structure, or NULL upon an error.

## sip_from_create()

sip_from_t * sip_from_create | ( | su_home_t * | home,
|  | url_string_t const * | s )

Create a From header object with URL.

Create a From header object.

Parameters

  home | memory home used to allocate sip_from_t structure
  s | pointer to the URL or a string

Returns
  A pointer to newly created From header object when successful or NULL upon an error.

## sip_from_dup()

sip_from_t * sip_from_dup | ( | su_home_t * | home,
|  | sip_from_t const * | hdr )

inline

Duplicate a list of From header header structures sip_from_t.

Duplicate a header structure hdr. If the header structure hdr contains a reference (`hdr->x_next`) to a list of headers, all the headers in the list are duplicated, too.

Parameters

  home | memory home used to allocate new structure
  hdr | header structure to be duplicated

When duplicating, all parameter lists and non-constant strings attached to the header are copied, too. The function uses given memory home to allocate all the memory areas used to copy the header.

Example
  from = sip_from_dup(home, sip->sip_from);
  sip_from_dup
  sip_from_t * sip_from_dup(su_home_t *home, sip_from_t const *hdr))
  Duplicate a list of From header header structures sip_from_t.
  Definition sip_protos.h:1901

Returns
  A pointer to the newly duplicated sip_from_t header structure, or NULL upon an error.

## sip_from_format()

sip_from_t * sip_from_format | ( | su_home_t * | home,
|  | char const * | fmt,
|  |  | ... )

inline

Make a From header from formatting result.

Make a new sip_from_t object using formatting result as its value. The function first prints the arguments according to the format fmt specified. Then it allocates a new header structure, and parses the formatting result to the structure sip_from_t.

Parameters

  home | memory home used to allocate new header structure.
  fmt | string used as a printf()-style format
  ... | argument list for format

Returns
  A pointer to newly makes header structure, or NULL upon an error.

## sip_from_init()

sip_from_t * sip_from_init | ( | sip_from_t | x[1] | ) |

inline

Initialize a structure sip_from_t.

An sip_from_t structure for From header can be initialized with the sip_from_init() function/macro. For instance,

sip_from_t sip_from;
sip_from_init(&sip_from);
sip_from_init
sip_from_t * sip_from_init(sip_from_t x[1])
Initialize a structure sip_from_t.
Definition sip_protos.h:1832

## sip_from_make()

sip_from_t * sip_from_make | ( | su_home_t * | home,
|  | char const * | s )

inline

Make a From header structure sip_from_t.

The function sip_from_make() makes a new sip_from_t header structure. It allocates a new header structure, and decodes the string s as the value of the structure.

Parameters

  home | memory home used to allocate new header structure.
  s | string to be decoded as value of the new header structure

Returns
  A pointer to newly maked sip_from_t header structure, or NULL upon an error.

## sip_from_tag()

int sip_from_tag | ( | su_home_t * | home,
|  | sip_from_t * | from,
|  | char const * | tag )

Add a tag to a From header.

If tag is identical with the existing one, nothing will be done. An error is returned, if the header already contains a different tag. The tag can be provided either as a single token ("deadbeer") or as in parameter form ("tag=deadbeer"). In both cases the tag is duplicated using the memory home home.

Parameters

  home | memory home used to allocate new tag
  from | From header to modify
  tag | tag token or parameter to be added

Return values

  0 | when successful
  -1 | upon an error.

## sip_is_from()

int sip_is_from | ( | sip_header_t const * | header | ) |

inline

Test if header object is instance of sip_from_t.

Check if the header class is an instance of From header object and return true (nonzero), otherwise return false (zero).

Parameters

  header | pointer to the header structure to be tested

Return values

  1 | (true) if the header is an instance of header from
  0 | (false) otherwise

## Variable Documentation

## sip_from_class

msg_hclass_t sip_from_class[]

extern

Header class for From header.

The header class sip_from_class defines how a SIP From header is parsed and printed. It also contains methods used by SIP parser and other functions to manipulate the sip_from_t header structure.

Sofia-SIP 1.12.11devel - Copyright (C) 2006 Nokia Corporation. All rights reserved. Licensed under the terms of the GNU Lesser General Public License.